#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators.SpeculatorSethFree
{
	public class spsfBidAskPrice : Indicator
	{
		private double _bid;
		private double _ask;
		
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Enter the description for your new custom Indicator here.";
				Name										= "spsfBidAskPrice";
				Calculate									= Calculate.OnBarClose;
				IsOverlay									= true;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= true;
				
				AddPlot(Brushes.CornflowerBlue, "Bid");
				AddPlot(Brushes.Orange, "Ask");
			}
			else if (State == State.Configure)
			{
			}
		}

		protected override void OnBarUpdate()
		{
			//Add your custom indicator logic here.		
			Values[0][0] = _bid;
			Values[1][0] = _ask;
		}
		
		protected override void OnMarketData(MarketDataEventArgs e)
		{
			_bid = e.Bid;
			_ask = e.Ask;
		}
	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private SpeculatorSethFree.spsfBidAskPrice[] cachespsfBidAskPrice;
		public SpeculatorSethFree.spsfBidAskPrice spsfBidAskPrice()
		{
			return spsfBidAskPrice(Input);
		}

		public SpeculatorSethFree.spsfBidAskPrice spsfBidAskPrice(ISeries<double> input)
		{
			if (cachespsfBidAskPrice != null)
				for (int idx = 0; idx < cachespsfBidAskPrice.Length; idx++)
					if (cachespsfBidAskPrice[idx] != null &&  cachespsfBidAskPrice[idx].EqualsInput(input))
						return cachespsfBidAskPrice[idx];
			return CacheIndicator<SpeculatorSethFree.spsfBidAskPrice>(new SpeculatorSethFree.spsfBidAskPrice(), input, ref cachespsfBidAskPrice);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.SpeculatorSethFree.spsfBidAskPrice spsfBidAskPrice()
		{
			return indicator.spsfBidAskPrice(Input);
		}

		public Indicators.SpeculatorSethFree.spsfBidAskPrice spsfBidAskPrice(ISeries<double> input )
		{
			return indicator.spsfBidAskPrice(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.SpeculatorSethFree.spsfBidAskPrice spsfBidAskPrice()
		{
			return indicator.spsfBidAskPrice(Input);
		}

		public Indicators.SpeculatorSethFree.spsfBidAskPrice spsfBidAskPrice(ISeries<double> input )
		{
			return indicator.spsfBidAskPrice(input);
		}
	}
}

#endregion
