#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators.SpeculatorSethFree
{
	public class spsfBidAskSpread : Indicator
	{
		public double _spread = 0;
		
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Enter the description for your new custom Indicator here.";
				Name										= "BidAskSpread";
				Calculate									= Calculate.OnBarClose;
				IsOverlay									= false;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= true;
				
				AddPlot(Brushes.CornflowerBlue, "Bid");
			}
			else if (State == State.Configure)
			{
			}
		}

		
		protected override void OnBarUpdate()
		{
			//Add your custom indicator logic here.		
			Value[0] = _spread;
			_spread = 0;
		}
		
		protected override void OnMarketData(MarketDataEventArgs e)
		{
			double spread = e.Ask - e.Bid;
			int ticks = Convert.ToInt32(spread / TickSize);
			
			_spread = Math.Max(_spread, ticks);
		}
	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private SpeculatorSethFree.spsfBidAskSpread[] cachespsfBidAskSpread;
		public SpeculatorSethFree.spsfBidAskSpread spsfBidAskSpread()
		{
			return spsfBidAskSpread(Input);
		}

		public SpeculatorSethFree.spsfBidAskSpread spsfBidAskSpread(ISeries<double> input)
		{
			if (cachespsfBidAskSpread != null)
				for (int idx = 0; idx < cachespsfBidAskSpread.Length; idx++)
					if (cachespsfBidAskSpread[idx] != null &&  cachespsfBidAskSpread[idx].EqualsInput(input))
						return cachespsfBidAskSpread[idx];
			return CacheIndicator<SpeculatorSethFree.spsfBidAskSpread>(new SpeculatorSethFree.spsfBidAskSpread(), input, ref cachespsfBidAskSpread);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.SpeculatorSethFree.spsfBidAskSpread spsfBidAskSpread()
		{
			return indicator.spsfBidAskSpread(Input);
		}

		public Indicators.SpeculatorSethFree.spsfBidAskSpread spsfBidAskSpread(ISeries<double> input )
		{
			return indicator.spsfBidAskSpread(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.SpeculatorSethFree.spsfBidAskSpread spsfBidAskSpread()
		{
			return indicator.spsfBidAskSpread(Input);
		}

		public Indicators.SpeculatorSethFree.spsfBidAskSpread spsfBidAskSpread(ISeries<double> input )
		{
			return indicator.spsfBidAskSpread(input);
		}
	}
}

#endregion
