#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators.SpeculatorSethFree
{
	public class spsfChangePercent : Indicator
	{
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Enter the description for your new custom Indicator here.";
				Name										= "ChangePercent";
				Calculate									= Calculate.OnBarClose;
				IsOverlay									= false;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= true;
				
				AddPlot(new Stroke(Brushes.Goldenrod, 2), PlotStyle.Bar, "Change");
			}
			else if (State == State.Configure)
			{
			}
		}

		protected override void OnBarUpdate()
		{
			Value[0] = (Close[0] - Open[0]) / Open[0];
			//Add your custom indicator logic here.
		}
	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private SpeculatorSethFree.spsfChangePercent[] cachespsfChangePercent;
		public SpeculatorSethFree.spsfChangePercent spsfChangePercent()
		{
			return spsfChangePercent(Input);
		}

		public SpeculatorSethFree.spsfChangePercent spsfChangePercent(ISeries<double> input)
		{
			if (cachespsfChangePercent != null)
				for (int idx = 0; idx < cachespsfChangePercent.Length; idx++)
					if (cachespsfChangePercent[idx] != null &&  cachespsfChangePercent[idx].EqualsInput(input))
						return cachespsfChangePercent[idx];
			return CacheIndicator<SpeculatorSethFree.spsfChangePercent>(new SpeculatorSethFree.spsfChangePercent(), input, ref cachespsfChangePercent);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.SpeculatorSethFree.spsfChangePercent spsfChangePercent()
		{
			return indicator.spsfChangePercent(Input);
		}

		public Indicators.SpeculatorSethFree.spsfChangePercent spsfChangePercent(ISeries<double> input )
		{
			return indicator.spsfChangePercent(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.SpeculatorSethFree.spsfChangePercent spsfChangePercent()
		{
			return indicator.spsfChangePercent(Input);
		}

		public Indicators.SpeculatorSethFree.spsfChangePercent spsfChangePercent(ISeries<double> input )
		{
			return indicator.spsfChangePercent(input);
		}
	}
}

#endregion
