#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators.SpeculatorSethFree
{
	[Gui.CategoryOrder("Parameters", 1)]
	[Gui.CategoryOrder("Display", 15)]
	[Gui.CategoryOrder("Data Series", 20)]
	[Gui.CategoryOrder("Setup", 30)]
	[Gui.CategoryOrder("Visual", 40)]
	[Gui.CategoryOrder("Plots", 50)]
	[Gui.CategoryOrder("Version", 80)]	
	public class spsfCurrentBarDebugTool : Indicator
	{
		private string	versionString = "v 1.0  -  Sept 15, 2022";
		
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Debugging tool to show the CurrentBar value of each bar.";
				Name										= "CurrentBarDebugTool";
				Calculate									= Calculate.OnBarClose;
				IsOverlay									= false;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= true;
				
				
				AddPlot(new Stroke(Brushes.White, 2), PlotStyle.Line, "CurrentBar");
			}
			else if (State == State.Configure)
			{
			}
		}

		protected override void OnBarUpdate()
		{
			//Add your custom indicator logic here.
			Value[0] = CurrentBar;
		}

		[XmlIgnore]
		[Display(ResourceType = typeof(Custom.Resource), Name = "Release and date", Description = "Release and date", GroupName = "Version", Order = 0)]
		public string VersionString
		{	
            get { return versionString; }
            set { ; }
		}
	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private SpeculatorSethFree.spsfCurrentBarDebugTool[] cachespsfCurrentBarDebugTool;
		public SpeculatorSethFree.spsfCurrentBarDebugTool spsfCurrentBarDebugTool()
		{
			return spsfCurrentBarDebugTool(Input);
		}

		public SpeculatorSethFree.spsfCurrentBarDebugTool spsfCurrentBarDebugTool(ISeries<double> input)
		{
			if (cachespsfCurrentBarDebugTool != null)
				for (int idx = 0; idx < cachespsfCurrentBarDebugTool.Length; idx++)
					if (cachespsfCurrentBarDebugTool[idx] != null &&  cachespsfCurrentBarDebugTool[idx].EqualsInput(input))
						return cachespsfCurrentBarDebugTool[idx];
			return CacheIndicator<SpeculatorSethFree.spsfCurrentBarDebugTool>(new SpeculatorSethFree.spsfCurrentBarDebugTool(), input, ref cachespsfCurrentBarDebugTool);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.SpeculatorSethFree.spsfCurrentBarDebugTool spsfCurrentBarDebugTool()
		{
			return indicator.spsfCurrentBarDebugTool(Input);
		}

		public Indicators.SpeculatorSethFree.spsfCurrentBarDebugTool spsfCurrentBarDebugTool(ISeries<double> input )
		{
			return indicator.spsfCurrentBarDebugTool(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.SpeculatorSethFree.spsfCurrentBarDebugTool spsfCurrentBarDebugTool()
		{
			return indicator.spsfCurrentBarDebugTool(Input);
		}

		public Indicators.SpeculatorSethFree.spsfCurrentBarDebugTool spsfCurrentBarDebugTool(ISeries<double> input )
		{
			return indicator.spsfCurrentBarDebugTool(input);
		}
	}
}

#endregion
