#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators.SpeculatorSethFree
{
	public class spsfDaysToExpiration : Indicator
	{
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Number of days until current contract rolls over.";
				Name										= "DaysToExpiration";
				Calculate									= Calculate.OnBarClose;
				IsOverlay									= false;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				BarsRequiredToPlot							= 0;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= true;
				
				AddPlot(Brushes.Orange, "Days To Expiration");
			}
			else if (State == State.Configure)
			{
			}
		}

		protected override void OnBarUpdate()
		{
			//Add your custom indicator logic here.
			var difference = Instrument.MasterInstrument.GetNextRolloverDate(Time[0]) - Time[0];
			Value[0] = difference.Days;
		}
	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private SpeculatorSethFree.spsfDaysToExpiration[] cachespsfDaysToExpiration;
		public SpeculatorSethFree.spsfDaysToExpiration spsfDaysToExpiration()
		{
			return spsfDaysToExpiration(Input);
		}

		public SpeculatorSethFree.spsfDaysToExpiration spsfDaysToExpiration(ISeries<double> input)
		{
			if (cachespsfDaysToExpiration != null)
				for (int idx = 0; idx < cachespsfDaysToExpiration.Length; idx++)
					if (cachespsfDaysToExpiration[idx] != null &&  cachespsfDaysToExpiration[idx].EqualsInput(input))
						return cachespsfDaysToExpiration[idx];
			return CacheIndicator<SpeculatorSethFree.spsfDaysToExpiration>(new SpeculatorSethFree.spsfDaysToExpiration(), input, ref cachespsfDaysToExpiration);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.SpeculatorSethFree.spsfDaysToExpiration spsfDaysToExpiration()
		{
			return indicator.spsfDaysToExpiration(Input);
		}

		public Indicators.SpeculatorSethFree.spsfDaysToExpiration spsfDaysToExpiration(ISeries<double> input )
		{
			return indicator.spsfDaysToExpiration(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.SpeculatorSethFree.spsfDaysToExpiration spsfDaysToExpiration()
		{
			return indicator.spsfDaysToExpiration(Input);
		}

		public Indicators.SpeculatorSethFree.spsfDaysToExpiration spsfDaysToExpiration(ISeries<double> input )
		{
			return indicator.spsfDaysToExpiration(input);
		}
	}
}

#endregion
