#region Using declarations
using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators.SpeculatorSethFree
{
	[Gui.CategoryOrder("Parameters", 1)]
	[Gui.CategoryOrder("Display", 15)]
	[Gui.CategoryOrder("Data Series", 20)]
	[Gui.CategoryOrder("Setup", 30)]
	[Gui.CategoryOrder("Visual", 40)]
	[Gui.CategoryOrder("Plots", 50)]
	[Gui.CategoryOrder("Version", 80)]	
	public class spsfExportLevelsFree : Indicator
	{
		private string	versionString = "v 1.0  -  Sept 15, 2022";
		private PriorDayOHLC _pOHLC;		
		
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Enter the description for your new custom Indicator here.";
				Name										= "ExportLevelsBasic";
				Calculate									= Calculate.OnBarClose;
				IsOverlay									= true;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= true;
				
				OutputFile = "jigsaw.csv";
			}
			else if (State == State.Configure)
			{
				_pOHLC = PriorDayOHLC();
			}
			else if (State == State.Transition)
			{
				Print("Exporting to: " + NinjaTrader.Core.Globals.UserDataDir + OutputFile);
				
				//Add your custom indicator logic here.
				using(StreamWriter writetext = new StreamWriter(NinjaTrader.Core.Globals.UserDataDir + OutputFile))
				{				
					writetext.WriteLine(_pOHLC.PriorOpen[0] + ", pO");
					writetext.WriteLine(_pOHLC.PriorHigh[0] + ", pH");
					writetext.WriteLine(_pOHLC.PriorLow[0] + ", pL");
					writetext.WriteLine(_pOHLC.PriorClose[0] + ", pC");
				}
			}
		}

		protected override void OnBarUpdate()
		{

		}
		
		#region Properties
		
		// Plot Bull/Bear Zone History
		[Display(Name = "Output File", Description = "Path to file to export to")]
		public string OutputFile
		{ get; set; }
		
		[XmlIgnore]
		[Display(ResourceType = typeof(Custom.Resource), Name = "Release and date", Description = "Release and date", GroupName = "Version", Order = 0)]
		public string VersionString
		{	
            get { return versionString; }
            set { ; }
		}
		
		#endregion
	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private SpeculatorSethFree.spsfExportLevelsFree[] cachespsfExportLevelsFree;
		public SpeculatorSethFree.spsfExportLevelsFree spsfExportLevelsFree()
		{
			return spsfExportLevelsFree(Input);
		}

		public SpeculatorSethFree.spsfExportLevelsFree spsfExportLevelsFree(ISeries<double> input)
		{
			if (cachespsfExportLevelsFree != null)
				for (int idx = 0; idx < cachespsfExportLevelsFree.Length; idx++)
					if (cachespsfExportLevelsFree[idx] != null &&  cachespsfExportLevelsFree[idx].EqualsInput(input))
						return cachespsfExportLevelsFree[idx];
			return CacheIndicator<SpeculatorSethFree.spsfExportLevelsFree>(new SpeculatorSethFree.spsfExportLevelsFree(), input, ref cachespsfExportLevelsFree);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.SpeculatorSethFree.spsfExportLevelsFree spsfExportLevelsFree()
		{
			return indicator.spsfExportLevelsFree(Input);
		}

		public Indicators.SpeculatorSethFree.spsfExportLevelsFree spsfExportLevelsFree(ISeries<double> input )
		{
			return indicator.spsfExportLevelsFree(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.SpeculatorSethFree.spsfExportLevelsFree spsfExportLevelsFree()
		{
			return indicator.spsfExportLevelsFree(Input);
		}

		public Indicators.SpeculatorSethFree.spsfExportLevelsFree spsfExportLevelsFree(ISeries<double> input )
		{
			return indicator.spsfExportLevelsFree(input);
		}
	}
}

#endregion
