#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators.SpeculatorSethFree
{
	public class spsfInverse : Indicator
	{
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Displays inverse of input.  Useful for FX futures.";
				Name										= "Inverse";
				Calculate									= Calculate.OnPriceChange;
				IsOverlay									= false;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= true;
				
				AddPlot(Brushes.Yellow, "Inverse");
			}
			else if (State == State.Configure)
			{
			}
		}

		protected override void OnBarUpdate()
		{
			//Add your custom indicator logic here.
			Value[0] = 1 / Input[0];
		}
	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private SpeculatorSethFree.spsfInverse[] cachespsfInverse;
		public SpeculatorSethFree.spsfInverse spsfInverse()
		{
			return spsfInverse(Input);
		}

		public SpeculatorSethFree.spsfInverse spsfInverse(ISeries<double> input)
		{
			if (cachespsfInverse != null)
				for (int idx = 0; idx < cachespsfInverse.Length; idx++)
					if (cachespsfInverse[idx] != null &&  cachespsfInverse[idx].EqualsInput(input))
						return cachespsfInverse[idx];
			return CacheIndicator<SpeculatorSethFree.spsfInverse>(new SpeculatorSethFree.spsfInverse(), input, ref cachespsfInverse);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.SpeculatorSethFree.spsfInverse spsfInverse()
		{
			return indicator.spsfInverse(Input);
		}

		public Indicators.SpeculatorSethFree.spsfInverse spsfInverse(ISeries<double> input )
		{
			return indicator.spsfInverse(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.SpeculatorSethFree.spsfInverse spsfInverse()
		{
			return indicator.spsfInverse(Input);
		}

		public Indicators.SpeculatorSethFree.spsfInverse spsfInverse(ISeries<double> input )
		{
			return indicator.spsfInverse(input);
		}
	}
}

#endregion
