#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators.SpeculatorSethFree
{
	[Gui.CategoryOrder("Parameters", 1)]
	[Gui.CategoryOrder("Display", 15)]
	[Gui.CategoryOrder("Data Series", 20)]
	[Gui.CategoryOrder("Setup", 30)]
	[Gui.CategoryOrder("Visual", 40)]
	[Gui.CategoryOrder("Plots", 50)]
	[Gui.CategoryOrder("Version", 80)]	
	public class spsfLabelRemover : Indicator
	{
		private string	versionString = "v 1.0  -  Sept 15, 2022";

		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Removes labels from all indicators on chart.";
				Name										= "LabelRemover";
				Calculate									= Calculate.OnBarClose;
				IsOverlay									= true;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= true;
			}
			else if (State == State.DataLoaded)
			{
				if (ChartControl == null) return;
				
				foreach (NinjaTrader.Gui.NinjaScript.IndicatorRenderBase indicator in ChartControl.Indicators)
				{
					indicator.Name = "";
				}
			}
		}

		protected override void OnBarUpdate()
		{
			//Add your custom indicator logic here.
		}

		[XmlIgnore]
		[Display(ResourceType = typeof(Custom.Resource), Name = "Release and date", Description = "Release and date", GroupName = "Version", Order = 0)]
		public string VersionString
		{	
            get { return versionString; }
            set { ; }
		}
	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private SpeculatorSethFree.spsfLabelRemover[] cachespsfLabelRemover;
		public SpeculatorSethFree.spsfLabelRemover spsfLabelRemover()
		{
			return spsfLabelRemover(Input);
		}

		public SpeculatorSethFree.spsfLabelRemover spsfLabelRemover(ISeries<double> input)
		{
			if (cachespsfLabelRemover != null)
				for (int idx = 0; idx < cachespsfLabelRemover.Length; idx++)
					if (cachespsfLabelRemover[idx] != null &&  cachespsfLabelRemover[idx].EqualsInput(input))
						return cachespsfLabelRemover[idx];
			return CacheIndicator<SpeculatorSethFree.spsfLabelRemover>(new SpeculatorSethFree.spsfLabelRemover(), input, ref cachespsfLabelRemover);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.SpeculatorSethFree.spsfLabelRemover spsfLabelRemover()
		{
			return indicator.spsfLabelRemover(Input);
		}

		public Indicators.SpeculatorSethFree.spsfLabelRemover spsfLabelRemover(ISeries<double> input )
		{
			return indicator.spsfLabelRemover(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.SpeculatorSethFree.spsfLabelRemover spsfLabelRemover()
		{
			return indicator.spsfLabelRemover(Input);
		}

		public Indicators.SpeculatorSethFree.spsfLabelRemover spsfLabelRemover(ISeries<double> input )
		{
			return indicator.spsfLabelRemover(input);
		}
	}
}

#endregion
