#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators.SpeculatorSethFree
{
	public class spsfTradingDayOfMonth : Indicator
	{
		private SessionIterator _sessionIterator;
		
		private int _day = 0;
		
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"How many trading days into the month it is.";
				Name										= "TradingDayOfMonth";
				Calculate									= Calculate.OnBarClose;
				IsOverlay									= false;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				BarsRequiredToPlot							= 0;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= true;
				
				AddPlot(Brushes.Orange, "TradingDayOfMonth");
			}
			else if (State == State.Configure)
			{
				_sessionIterator = new SessionIterator(Bars);
			}
		}

		protected override void OnBarUpdate()
		{
			//Add your custom indicator logic here.
			if( CurrentBar == 0) return;
			
			DateTime previous = _sessionIterator.GetTradingDay(Time[1]);
			DateTime current = _sessionIterator.GetTradingDay(Time[0]);
			
			if(!current.Month.Equals(previous.Month))
			{
				_day = 1;
			}
			
			if(!current.DayOfWeek.Equals(previous.DayOfWeek) && current.Month.Equals(previous.Month) && _day != 0)
			{				
				_day++;
			}
			
			Value[0] = _day;
		}
	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private SpeculatorSethFree.spsfTradingDayOfMonth[] cachespsfTradingDayOfMonth;
		public SpeculatorSethFree.spsfTradingDayOfMonth spsfTradingDayOfMonth()
		{
			return spsfTradingDayOfMonth(Input);
		}

		public SpeculatorSethFree.spsfTradingDayOfMonth spsfTradingDayOfMonth(ISeries<double> input)
		{
			if (cachespsfTradingDayOfMonth != null)
				for (int idx = 0; idx < cachespsfTradingDayOfMonth.Length; idx++)
					if (cachespsfTradingDayOfMonth[idx] != null &&  cachespsfTradingDayOfMonth[idx].EqualsInput(input))
						return cachespsfTradingDayOfMonth[idx];
			return CacheIndicator<SpeculatorSethFree.spsfTradingDayOfMonth>(new SpeculatorSethFree.spsfTradingDayOfMonth(), input, ref cachespsfTradingDayOfMonth);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.SpeculatorSethFree.spsfTradingDayOfMonth spsfTradingDayOfMonth()
		{
			return indicator.spsfTradingDayOfMonth(Input);
		}

		public Indicators.SpeculatorSethFree.spsfTradingDayOfMonth spsfTradingDayOfMonth(ISeries<double> input )
		{
			return indicator.spsfTradingDayOfMonth(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.SpeculatorSethFree.spsfTradingDayOfMonth spsfTradingDayOfMonth()
		{
			return indicator.spsfTradingDayOfMonth(Input);
		}

		public Indicators.SpeculatorSethFree.spsfTradingDayOfMonth spsfTradingDayOfMonth(ISeries<double> input )
		{
			return indicator.spsfTradingDayOfMonth(input);
		}
	}
}

#endregion
